// 
// AYA version 5
//
// ȐsȂNX@CBasis
// written by umeici. 2004
// 

#ifndef POSIX
#  include "stdafx.h"
#else
#  include "messages.h"
#  include "posix_utils.h"
#  include <stdlib.h>
#  include <dirent.h>
#  include <sys/types.h>
#  include <sys/stat.h>
#  include <iostream>
using namespace std;
#endif
#include "basis.h"
#include "parser0.h"
#include "logexcode.h"
#include "comment.h"
#include "misc.h"
#include "log.h"
#include "wsex.h"
#include "ccct.h"
#include "file.h"
#include "lib.h"
#include "wordmatch.h"

extern vector<CFunction>	function;
extern CCallDepth			calldepth;
extern CGlobalVariable		variable;
extern CFile				files;
extern CLib					libs;
extern CLog					logger;


extern CWordMatch			formulatag_wm;


/* -----------------------------------------------------------------------
 * CBasisRXgN^
 * -----------------------------------------------------------------------
 */
CBasis::CBasis(void)
{
	ResetSurpress();
	CreateWordMatch();

	checkparser = 0;
	iolog       = 1;
	msglang     = MSGLANG_JAPANESE;
	charset     = CHARSET_SJIS;
#ifndef POSIX
	hlogrcvWnd  = NULL;
#endif
	run         = 0;
}

void CBasis::CreateWordMatch(void)
{
	for(int i = 0; i < FORMULATAG_NUM; i++)
		formulatag_wm.addWord(formulatag[i], i);
}


/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::SetModuleHandle
 *  @\TvF  W[nh擾܂
 *
 *  łɃW[̎t@C擾s܂
 * -----------------------------------------------------------------------
 */
#ifndef POSIX
void	CBasis::SetModuleHandle(HANDLE h)
{
	// W[nh擾
	hmodule = (HMODULE)h;

	// W[̎t@C擾
	// NTnł͂ȂUNICODEŎ擾ł邪A9xnlMBCSŎ擾ĂUCS-2֕ϊ
	char	path[STRMAX];
	GetModuleFileName(hmodule, path, sizeof(path));
	char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
	_splitpath(path, drive, dir, fname, ext);
	string	mbmodulename = fname;

	wchar_t	*wcmodulename = Ccct::MbcsToUcs2(mbmodulename, CHARSET_DEFAULT);
	modulename = wcmodulename;
	free(wcmodulename);
}
#endif

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::SetPath
 *  @\TvF  HGLOBALɊi[ꂽt@CpX擾AHGLOBAL͊J܂
 * -----------------------------------------------------------------------
 */
#ifndef POSIX
void	CBasis::SetPath(HGLOBAL h, int len)
{
	// 擾Ɨ̈J
	string	mbpath;
	mbpath.assign((char *)h, 0, len);
	GlobalFree(h);
	// R[hUCS-2֕ϊił̃}`oCgR[hOSftHgj
	wchar_t	*wcpath = Ccct::MbcsToUcs2(mbpath, CHARSET_DEFAULT);
	path = wcpath;
	free(wcpath);
}
#else
void CBasis::SetPath(char* h, long len) {
    // 擾Ɨ̈J
    path = widen(string(h, static_cast<string::size_type>(len)));
    free(h);
    // XbVŏIĂȂΕtB
    if (path.length() == 0 || path[path.length() - 1] != L'/') {
	path += L'/';
    }
    // W[nh̎擾͏oȂ̂ŁA͋ZňʒumB
    // ̃fBNgɂSĂ*.dll(case insensitive)TA
    // gaya5.dllƂ܂łAIԁB
    // Ή*.txtdll̒g͌Ɏ֍sB
    modulename = L"aya5";
    DIR* dh = opendir(narrow(path).c_str());
    if (dh == NULL) {
	cerr << narrow(path) << "is not a directory!" << endl;
	exit(1);
    }
    while (true) {
	struct dirent* ent = readdir(dh);
	if (ent == NULL) {
	    break; // 
	}
	string fname(ent->d_name, strlen(ent->d_name)/*ent->d_namlen*/);	// by umeici. 2005/1/16 5.6.0.232
	if (lc(get_extension(fname)) == "dll") {
	    string txt_file = narrow(path) + change_extension(fname, "txt");
	    struct stat sb;
	    if (::stat(txt_file.c_str(), &sb) == 0) {
		// txtt@ĈŁAgĂ݂B
		if (file_content_search(narrow(path) + fname, "aya5.dll") != string::npos) {
		    // ͕DLLłB
		    modulename = widen(drop_extension(fname));
		    break;
		}
	    }
	}
    }
    closedir(dh);
}
#endif

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::SetLogRcvWnd
 *  @\TvF  `FbNc[nꂽhWndێ܂
 * -----------------------------------------------------------------------
 */
#ifndef POSIX
void	CBasis::SetLogRcvWnd(long hwnd)
{
	hlogrcvWnd = (HWND)hwnd;
}
#endif

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::Configure
 *  @\TvF  loadɍsݒ菈
 * -----------------------------------------------------------------------
 */
void	CBasis::Configure(void)
{
	// bݒt@CiႦaya.txtjǂݎ
	vector<wstring>	dics;
	LoadBaseConfigureFile(&dics);
	// bݒt@CǂݎŏdĂȃG[ꍇ͂ŏI
	if (surpress)
		return;

	// MOJn
#ifndef POSIX
	logger.Start(logpath, charset, msglang, hlogrcvWnd, iolog);
#else
	logger.Start(logpath, charset, msglang, iolog);
#endif

	// ǂݍ݂ƍ\
	if (CParser0::Parse(charset, dics, loadindex, unloadindex, requestindex))
		SetSurpress();

	if (checkparser)
		CLogExCode::OutExecutionCodeForCheck();

	// OIɕۑϐ𕜌
	RestoreVariable();

	if (checkparser)
		CLogExCode::OutVariableInfoForCheck();

	// ܂ł̏ŏdĂȃG[ꍇ͂ŏI
	if (surpress)
		return;

	// OCuƃt@C̕R[h
	libs.SetCharset(charset);
	files.SetCharset(charset);

	// load֐s
	ExecuteLoad();

	run = 1;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::Termination
 *  @\TvF  unloadɍsI
 * -----------------------------------------------------------------------
 */
void	CBasis::Termination(void)
{
	// }~ĂȂΏȈs
	if (!surpress) {
		// unload
		ExecuteUnload();
		// [hĂ邷ׂẴCuunload
		libs.DeleteAll();
		// JĂ邷ׂẴt@C
		files.DeleteAll();
		// ϐ̕ۑ
		SaveVariable();
	}

	// MOI
	logger.Termination();
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::IsSurpress
 *  @\TvF  ݂̎}~ԂԂ܂
 *
 *  Ԓl@@F  0/1=}~/}~
 *
 *  bݒt@C̓ǂݎ⎫t@C̉͒ɁApȃG[
 *  SetSurpress()ɂė}~ݒ肳܂B}~ݒ肳ƁAload/request/unloadł̓삪
 *  ׂă}XN܂B̎Arequest̕Ԓl͏ɋ󕶎ɂȂ܂BiHGLOBAL=NULLA
 *  len=0ŉ܂j
 * -----------------------------------------------------------------------
 */
char	CBasis::IsSurpress(void)
{
	return surpress;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::SetSurpress
 *  @\TvF  }~ݒ肵܂
 * -----------------------------------------------------------------------
 */
void	CBasis::SetSurpress(void)
{
	surpress = 1;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::ResetSurpress
 *  @\TvF  }~@\Zbg܂
 * -----------------------------------------------------------------------
 */
void	CBasis::ResetSurpress(void)
{
	surpress = 0;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::LoadBaseConfigureFile
 *  @\TvF  bݒt@CǂݎAep[^Zbg܂
 *
 *  bݒt@CDLLƓKwɑ݂閼O"DLLt@C.txt"̃t@CłB
 *
 *  t@C̕R[hShift_JISȊOɂUTF-8OSftHg̃R[hɑΉł܂A
 *  ̊bݒt@COSftHg̃R[hœǂݎ邱ƂɒӂĂB
 *  ۉɊւčlꍇ́Ãt@C̋LqɃ}`oCggpׂł
 *  ܂iR[h0x7FȉASCIÎ݂ŋLqׂłjB
 * -----------------------------------------------------------------------
 */
void	CBasis::LoadBaseConfigureFile(vector<wstring> *dics)
{
	// ݒt@C("name".txt)ǂݎ

	// t@CJ
    	wstring	filename = path + modulename + L".txt";
	FILE	*fp = w_fopen((wchar_t *)filename.c_str(), L"r");
	if (fp == NULL) {
		SetSurpress();
		return;
	}

	// ǂݎ菈
	CComment	comment;
	for (int i = 1; ; i++) {
		// 1sǂݍ
		wstring	readline;
		if (ws_fgets(readline, fp, CHARSET_DEFAULT, 0, i) == WS_EOF)
			break;
		// s͏
		CutCrLf(readline);
		// RgAEg
		comment.ExecuteSS_Top(readline);
		comment.Execute(readline);
		comment.ExecuteSS_Tail(readline);
		// sA͑ŜRgsꍇ͎̍s
		if (readline.size() == 0)
			continue;
		// p[^ݒ
		wstring	cmd, param;
		if (Split(readline, cmd, param, L",")) {
			SetParameter(cmd, param, dics);
		}
		else {
			logger.Error(E_W, 0, filename, i);
		}
	}

	// t@C
	fclose(fp);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::SetParameter
 *  @\TvF  LoadBaseConfigureFileĂ΂܂Bep[^ݒ肵܂
 * -----------------------------------------------------------------------
 */
void	CBasis::SetParameter(wstring &cmd, wstring &param, vector<wstring> *dics)
{
	// dic
	if (!cmd.compare(L"dic")) {
		wstring	filename = path + param;
		dics->push_back(filename);
	}
	// log
	else if (!cmd.compare(L"log")) {
		logpath = path + param;
	}
	// iolog
	else if (!cmd.compare(L"iolog")) {
		if (!param.compare(L"off"))
			iolog = 0;
	}
	// msglang
	else if (!cmd.compare(L"msglang")) {
		if (!param.compare(L"english"))
			msglang = MSGLANG_ENGLISH;
		else
			msglang = MSGLANG_JAPANESE;
	}
	// charset
	else if (!cmd.compare(L"charset")) {
		if (!param.compare(L"UTF-8") || !param.compare(L"UTF8"))
			charset = CHARSET_UTF8;
		else if (!param.compare(L"default"))
			charset = CHARSET_DEFAULT;
		else if (!param.compare(L"Shift_JIS") || !param.compare(L"ShiftJIS") || !param.compare(L"SJIS"))
			charset = CHARSET_SJIS;
		else {
			logger.Error(E_N, 1, param);
			charset = CHARSET_DEFAULT;
		}
	}
	// fncdepth
	else if (!cmd.compare(L"fncdepth")) {
		int	f_depth = ws_atoi(param, 10);
		calldepth.SetMaxDepth((f_depth < 2) ? 2 : f_depth);
	}
	// checkparser@J@\
	
	else if (!cmd.compare(L"checkparser")) {
		if (!param.compare(L"on"))
			checkparser = 1;
	}
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::SaveVariable
 *  @\TvF  ϐlt@Cɕۑ܂
 *
 *  t@C"DLLt@C_variable.cfg"łB
 *  t@CtH[}bg1s1ϐAf~^pJ}ŁA
 *
 *  ϐ,e,f~^
 *
 *  ̌`ŕۑ܂Be͐/̏ꍇ͂̂܂܁Ał̓_uNH[g܂B
 *  z̏ꍇ͊evfԂRŕ܂Bȉɗvf3Af~^"@"ł̗܂B
 *
 *  var,1:"TEST":0.3,@
 *
 *  f~^̓_uNH[g܂B
 *
 *  bݒt@CŐݒ肵R[hŕۑ܂B
 * -----------------------------------------------------------------------
 */
void	CBasis::SaveVariable(void)
{
	// ϐ̕ۑ

	// t@CJ
	wstring	filename = path + modulename + L"_variable.cfg";
	logger.Message(7);
	logger.Filename(filename);
	FILE	*fp = w_fopen((wchar_t *)filename.c_str(), L"w");
	if (fp == NULL) {
		logger.Error(E_E, 57, filename);
		return;
	}
/*
#ifndef POSIX
	// UTF-8̏ꍇ͐擪BOMۑ
	if (charset == CHARSET_UTF8)
		write_utf8bom(fp);
#endif
	// UTF-8Ȃ̂BOMt̂͂߂XƁc
	// gǔɂȂ̂ŁB

	// łBOĂ܂܂B
	// 
	// UTF-8ɂ̓oCgI[_[ɂoG[V݂Ȃ̂BOM͕KvȂB
	// t^邱Ƃ͏oBΉĂȂ\tgœǂ߂ȂȂ̂ŕtȂق
	// ǂB
*/
	// ۑ
	wstring	wstr;
	int	c_ch;
	char	*tmpstr;
	int	var_num = variable.GetNumber();
	for(int i = 0; i < var_num; i++) {
		CVariable	*var = variable.GetPtr(i);
		// e󕶎̕ϐ͕ۑȂ
		if (var->v.GetType() == F_TAG_STRING && !var->v.s_value.size())
			continue;
		// eėpz̕ϐ͕ۑȂ
//		if (var->v.GetType() == F_TAG_ARRAY && !var->v.array.size())
//			continue;
		// tOĂϐ͕ۑȂ
		if (var->IsErased())
			continue;
		// O̕ۑ
		tmpstr = Ccct::Ucs2ToMbcs(var->name, charset);
		fprintf(fp, "%s,", tmpstr);
		free(tmpstr);
		// l̕ۑ
		vector<CValueSub>::iterator	itv;
		switch(var->v.GetType()) {
		case F_TAG_INT:
			ws_itoa(wstr, var->v.i_value, 10);
			tmpstr = Ccct::Ucs2ToMbcs(wstr, charset);
			fprintf(fp, "%s,", tmpstr);
			free(tmpstr);
			break;
		case F_TAG_DOUBLE:
			ws_ftoa(wstr, var->v.d_value);
			tmpstr = Ccct::Ucs2ToMbcs(wstr, charset);
			fprintf(fp, "%s,", tmpstr);
			free(tmpstr);
			break;
		case F_TAG_STRING:
			wstr = var->v.s_value;
			ws_replace(wstr, L"\"", wstring(ESC_DQ));
			for(c_ch = 1; c_ch <= END_OF_CTRL_CH; c_ch++)
				ws_replace(wstr, wstring() + (wchar_t)c_ch,
					wstring(ESC_CTRL) + (wchar_t)(c_ch + CTRL_CH_START));
			wstr = L"\"" + wstr + L"\"";
			tmpstr = Ccct::Ucs2ToMbcs(wstr, charset);
			fprintf(fp, "%s,", tmpstr);
			free(tmpstr);
			break;
		case F_TAG_ARRAY:
			if (!var->v.array.size()) {
				fprintf(fp, ESC_IARRAY_SAVE);
				fprintf(fp, ":");
				fprintf(fp, ESC_IARRAY_SAVE);
			}
			else {
				for(itv = var->v.array.begin(); itv != var->v.array.end(); itv++) {
					if (itv != var->v.array.begin())
						fprintf(fp, ":");
					wstr = itv->GetValueString();
					ws_replace(wstr, L"\"", wstring(ESC_DQ));
					for(c_ch = 1; c_ch <= END_OF_CTRL_CH; c_ch++)
						ws_replace(wstr, wstring() + (wchar_t)c_ch,
							wstring(ESC_CTRL) + (wchar_t)(c_ch + CTRL_CH_START));
					tmpstr = Ccct::Ucs2ToMbcs(wstr, charset);
					if (itv->GetType() == F_TAG_STRING)
						fprintf(fp, "\"%s\"", tmpstr);
					else
						fprintf(fp, "%s", tmpstr);
					free(tmpstr);
				}
				if (var->v.array.size() == 1) {
					fprintf(fp, ":");
					fprintf(fp, ESC_IARRAY_SAVE);
				}
			}
			fprintf(fp, ",");
			break;
		default:
			logger.Error(E_W, 7, var->name);
			break;
		};
		// f~^̕ۑ
		tmpstr = Ccct::Ucs2ToMbcs(var->delimiter, charset);
		fprintf(fp, "%s\n", tmpstr);
		free(tmpstr);
	}

	// t@C
	fclose(fp);

	logger.Message(8);
}
/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::RestoreVariable
 *  @\TvF  Oۑϐe𕜌܂
 * -----------------------------------------------------------------------
 */
void	CBasis::RestoreVariable(void)
{
	// t@CJ
	wstring	filename = path + modulename + L"_variable.cfg";
	logger.Message(6);
	logger.Filename(filename);
	FILE	*fp = w_fopen((wchar_t *)filename.c_str(), L"r");
	if (fp == NULL) {
		logger.Error(E_N, 0);
		return;
	}

	// eǂݎAĂ
	wstring	linebuffer;
	for (int i = 1; ; i++) {
		// 1sǂݍ
		wstring	readline;
		if (ws_fgets(readline, fp, charset, 0, i) == WS_EOF)
			break;
		// s͏
		CutCrLf(readline);
		// sȂ玟̍s
		if (readline.size() == 0) {
			linebuffer = L"";
			continue;
		}
		// ɓǂݎς̕ƌ
		linebuffer += readline;
		// _uNH[e[VĂ邩mFBĂȂꍇ́A
		// ̍s֒lĂƎv̂Ŏ̍s̓ǂݎ
		if (IsInDQ(linebuffer, 0, linebuffer.size() - 1))
			continue;

		wstring	parseline = linebuffer;
		linebuffer = L"";
		// ϐ擾
		CVariable	addvariable;
		wstring	varname, value, delimiter;
		if (!Split_IgnoreDQ(parseline, varname, value, L",")) {
			logger.Error(E_W, 1, filename, i);
			continue;
		}
		// ϐ̐
		if (IsLegalVariableName(varname)) {
			logger.Error(E_W, 2, filename, i);
			continue;
		}
		// lƃf~^o
		parseline = value;
		if (!Split_IgnoreDQ(parseline, value, delimiter, L",")) {
			logger.Error(E_W, 3, filename, i);
			continue;
		}
		// l`FbNČ^𔻒
		int	type;
		if (IsIntString(value))
			type = F_TAG_INT;
		else if (IsDoubleString(value))
			type = F_TAG_DOUBLE;
		else if (!IsLegalStrLiteral(value))
			type = F_TAG_STRING;
		else {
			if (value.find(L':') == -1) {
				logger.Error(E_W, 4, filename, i);
				continue;
			}
			type = F_TAG_ARRAY;
		}
		// f~^̐
		if (!delimiter.size()) {
			logger.Error(E_W, 5, filename, i);
			continue;
		}
		// ϐ쐬
		int	index = variable.Make(varname, 0);
		variable.SetType(index, type);
		if (type == F_TAG_INT)
			// ^
			variable.SetValue(index, ws_atoi(value, 10));
		else if (type == F_TAG_DOUBLE) 
			// ^
			variable.SetValue(index, ws_atof(value));
		else if (type == F_TAG_STRING) {
			// ^
			CutDoubleQuote(value);
			ws_replace(value, wstring(ESC_DQ), L"\"");
			for(int c_ch = 1; c_ch <= END_OF_CTRL_CH; c_ch++)
				ws_replace(value, wstring(ESC_CTRL) + (wchar_t)(c_ch + CTRL_CH_START),
					wstring() + (wchar_t)c_ch);
			variable.SetValue(index, value);
		}
		else if (type == F_TAG_ARRAY)
			// z^
			RestoreArrayVariable(*(variable.GetValuePtr(index)), value);
		else {
			logger.Error(E_W, 6, filename, i);
			continue;
		}
		variable.SetDelimiter(index, delimiter);
	}

	// t@C
	fclose(fp);

	logger.Message(8);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::RestoreArrayVariable
 *  @\TvF  RestoreVariableĂ΂܂Bzϐ̓e𕜌܂
 * -----------------------------------------------------------------------
 */
void	CBasis::RestoreArrayVariable(CValue &var, wstring &value)
{
	var.array.clear();

	for( ; ; ) {
		CValueSub	addvs;
		wstring	par, remain;
		if (!Split_IgnoreDQ(value, par, remain, L":")) {
			if (!value.compare(ESC_IARRAY))
				break;
			else if (IsIntString(value))
				addvs = ws_atoi(value, 10);
			else if (IsDoubleString(value))
				addvs = ws_atof(value);
			else {
				addvs = value;
				CutDoubleQuote(addvs.s_value);
				ws_replace(addvs.s_value, wstring(ESC_DQ), L"\"");
				for(int c_ch = 1; c_ch <= END_OF_CTRL_CH; c_ch++)
					ws_replace(addvs.s_value, wstring(ESC_CTRL) + (wchar_t)(c_ch + CTRL_CH_START),
						wstring() + (wchar_t)c_ch);
			}
			var.array.push_back(addvs);
			break;
		}

		if (!par.compare(ESC_IARRAY)) {
			value = remain;
			continue;
		}
		else if (IsIntString(par))
			addvs = ws_atoi(par, 10);
		else if (IsDoubleString(par))
			addvs = ws_atof(par);
		else {
			addvs = par;
			CutDoubleQuote(addvs.s_value);
			ws_replace(addvs.s_value, wstring(ESC_DQ), L"\"");
			for(int c_ch = 1; c_ch <= END_OF_CTRL_CH; c_ch++)
				ws_replace(addvs.s_value, wstring(ESC_CTRL) + (wchar_t)(c_ch + CTRL_CH_START),
					wstring() + (wchar_t)c_ch);
		}
		var.array.push_back(addvs);
		value = remain;
	}
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::ExecuteLoad
 *  @\TvF  load֐s܂
 * -----------------------------------------------------------------------
 */
void	CBasis::ExecuteLoad(void)
{
	if (IsSurpress() || loadindex == -1)
		return;

	// idll̃pXj쐬
	CValue	arg(F_TAG_ARRAY, 0/*dmy*/);
	CValueSub	arg0(path);
	arg.array.push_back(arg0);
	// s@ʂ͎gpȂ̂ł̂܂܎̂Ă
	calldepth.Init();
	CLocalVariable	lvar;
	int	exitcode;
	logger.Io(0, path);
	function[loadindex].Execute(arg, lvar, exitcode);
	wstring empty;
	logger.Io(1, empty);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::ExecuteRequest
 *  @\TvF  request֐s܂
 * -----------------------------------------------------------------------
 */
#ifndef POSIX
HGLOBAL	CBasis::ExecuteRequest(HGLOBAL h, long *len)
{
	if (IsSurpress() || requestindex == -1) {
		GlobalFree(h);
		*len = 0;
		return NULL;
	}

	// ͕擾
	string	istr;
	istr.assign((char *)h, 0, (int)*len);
	GlobalFree(h);
	// i͕j쐬@ŕR[hUCS-2֕ϊ
	CValue	arg(F_TAG_ARRAY, 0/*dmy*/);
	wchar_t	*wistr = Ccct::MbcsToUcs2(istr, charset);
	if (wistr != NULL) {
		CValueSub	arg0 = wistr;
		logger.Io(0, arg0.s_value);
		arg.array.push_back(arg0);
		free(wistr);
	}
	else
		logger.Io(0, wstring(L""));
	// s
	calldepth.Init();
	CLocalVariable	lvar;
	int	exitcode;
	CValue	result = function[requestindex].Execute(arg, lvar, exitcode);
	// ʂ𕶎ƂĎ擾AR[hMBCSɕϊ
	wstring	res = result.GetValueString();
	logger.Io(1, res);
	char	*mostr = Ccct::Ucs2ToMbcs(res, charset);
	if (mostr == NULL) {
		// R[hϊsANULLԂ
		*len = 0;
		return NULL;
	}
	// R[hϊ̂ŁAʂGMEMփRs[ĕԂ
	*len = (long)strlen(mostr);
	HGLOBAL	r_h = ::GlobalAlloc(GMEM_FIXED, *len);
	memcpy(r_h, mostr, *len);
	free(mostr);
	return r_h;
}
#else
char* CBasis::ExecuteRequest(char* h, long* len) {
    if (IsSurpress() || requestindex == -1) {
	free(h);
	*len = 0;
	return NULL;
    }
    
    // ͕擾
    string istr(h, *len);
    // i͕j쐬@ŕR[hUCS-2֕ϊ
    CValue arg(F_TAG_ARRAY, 0/*dmy*/);
    wchar_t *wistr = Ccct::MbcsToUcs2(istr, charset);
    if (wistr != NULL) {
	CValueSub arg0 = wistr;
	logger.Io(0, arg0.s_value);
	arg.array.push_back(arg0);
	free(wistr);
    }
    else {
	wstring empty;
	logger.Io(0, empty);
    }
    
    // s
    calldepth.Init();
    CLocalVariable	lvar;
    int	exitcode;
    CValue	result = function[requestindex].Execute(arg, lvar, exitcode);
    // ʂ𕶎ƂĎ擾AR[hMBCSɕϊ
    wstring	res = result.GetValueString();
    logger.Io(1, res);
    char *mostr = Ccct::Ucs2ToMbcs(res, charset);
    if (mostr == NULL) {
	// R[hϊsANULLԂ
	*len = 0;
	return NULL;
    }
    // R[hϊ̂ŁAʂGMEMփRs[ĕԂ
    *len = (long)strlen(mostr);
    char* r_h = static_cast<char*>(malloc(*len));
    memcpy(r_h, mostr, *len);
    free(mostr);
    return r_h;
}
#endif

/* -----------------------------------------------------------------------
 *  ֐  F  CBasis::ExecuteUnload
 *  @\TvF  unload֐s܂
 * -----------------------------------------------------------------------
 */
void	CBasis::ExecuteUnload(void)
{
	if (IsSurpress()|| loadindex == -1)
		return;

	// s@@ʂ͎gpȂ̂ł̂܂܎̂Ă
	CValue	arg(F_TAG_ARRAY, 0/*dmy*/);
	calldepth.Init();
	CLocalVariable	lvar;
	int	exitcode;
	wstring empty;
	logger.Io(0, empty);
	function[unloadindex].Execute(arg, lvar, exitcode);
	logger.Io(1, empty);
}
