// 
// AYA version 5
//
// [JϐNX@CLocalVariable
// written by umeici. 2004
// 

#ifndef POSIX
#  include "stdafx.h"
#endif
#include "variable.h"
#include "value.h"
#include "misc.h"
#include "log.h"
#include "wsex.h"
#include "ccct.h"

extern CLog	logger;

/* -----------------------------------------------------------------------
 *  CLocalVariableRXgN^
 * -----------------------------------------------------------------------
 */
CLocalVariable::CLocalVariable(void)
{
	depth = -1;

	AddDepth();
}

/* -----------------------------------------------------------------------
 *  CLocalVariablefXgN^
 * -----------------------------------------------------------------------
 */
CLocalVariable::~CLocalVariable(void)
{
	stack.clear();
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::GetArgvAdr
 *  @\TvF  _argvi[Ăʒũ|C^Ԃ܂
 *
 *  vector͍Ċ蓖ĂɂăAhXω̂ŁAœl
 *  ꎞIɗp邱Ƃo܂B
 * -----------------------------------------------------------------------
 */
CVariable	*CLocalVariable::GetArgvPtr(void)
{
	return &(stack[0].substack[0]);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::AddDepth
 *  @\TvF  Kw[[JϐX^bN쐬܂
 * -----------------------------------------------------------------------
 */
void	CLocalVariable::AddDepth(void)
{
	CLVSubStack	addsubstack;
	stack.push_back(addsubstack);
	depth++;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::DelDepth
 *  @\TvF  ł[[JϐX^bNj܂
 * -----------------------------------------------------------------------
 */
void	CLocalVariable::DelDepth(void)
{
	if (stack.size()) {
		stack.erase(stack.end() - 1);
		depth--;
	}
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::Make
 *  @\TvF  [Jϐ쐬܂
 * -----------------------------------------------------------------------
 */
void	CLocalVariable::Make(const wchar_t *name)
{
	CVariable	addlv(name);
	stack[depth].substack.push_back(addlv);
}

//----

void	CLocalVariable::Make(const wstring &name)
{
	CVariable	addlv(name);
	stack[depth].substack.push_back(addlv);
}

//----

void	CLocalVariable::Make(const wchar_t *name, const CValue &value)
{
	CVariable	addlv(name);
	addlv.v = value;
	stack[depth].substack.push_back(addlv);
}

//----

void	CLocalVariable::Make(const wstring &name, const CValue &value)
{
	CVariable	addlv(name);
	addlv.v = value;
	stack[depth].substack.push_back(addlv);
}

//----

void	CLocalVariable::Make(const wstring &name, const CValueSub &value)
{
	CVariable	addlv(name);
	addlv.v = value;
	stack[depth].substack.push_back(addlv);
}

//----

void	CLocalVariable::Make(const wchar_t *name, const wstring &delimiter)
{
	CVariable	addlv(name);
	addlv.delimiter = delimiter;
	stack[depth].substack.push_back(addlv);
}

//----

void	CLocalVariable::Make(const wstring &name, const wstring &delimiter)
{
	CVariable	addlv(name);
	addlv.delimiter = delimiter;
	stack[depth].substack.push_back(addlv);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::GetIndex
 *  @\TvF  w肳ꂽÕ[JϐX^bN猟܂
 *
 *  Ȃꍇ-1Ԃ܂
 * -----------------------------------------------------------------------
 */
void	CLocalVariable::GetIndex(const wchar_t *name, int &id, int &dp)
{
	for(int i = stack.size() - 1; i >= 0; i--)
		for(int j = stack[i].substack.size() - 1; j >= 0; j--)
			if (!stack[i].substack[j].name.compare(name)) {
				if (stack[i].substack[j].IsErased()) {
					id = -1;
					dp = -1;
				}
				else {
					dp = i;
					id = j;
				}
				return;
			}

	id = -1;
	dp = -1;
}

//----

void	CLocalVariable::GetIndex(const wstring &name, int &id, int &dp)
{
	for(int i = stack.size() - 1; i >= 0; i--)
		for(int j = stack[i].substack.size() - 1; j >= 0; j--)
			if (!stack[i].substack[j].name.compare(name)) {
				if (stack[i].substack[j].IsErased()) {
					id = -1;
					dp = -1;
				}
				else {
					dp = i;
					id = j;
				}
				return;
			}

	id = -1;
	dp = -1;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::GetValue
 *  @\TvF  w肳ꂽ[Jϐ̒l擾܂
 *
 *  w肳ꂽϐ݂Ȃꍇ͋󕶎񂪕Ԃ܂B
 * -----------------------------------------------------------------------
 */

CValue	CLocalVariable::GetValue(const wchar_t *name)
{
	int	dp, id;
	GetIndex(name, id, dp);
	if (id >= 0)
		return stack[dp].substack[id].v;

	return CValue();
}

//----

CValue	CLocalVariable::GetValue(const wstring &name)
{
	int	dp, id;
	GetIndex(name, id, dp);
	if (id >= 0)
		return stack[dp].substack[id].v;

	return CValue();
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::GetDelimiter
 *  @\TvF  w肳ꂽ[Jϐ̃f~^擾܂
 * -----------------------------------------------------------------------
 */
wstring	CLocalVariable::GetDelimiter(const wchar_t *name)
{
	int	dp, id;
	GetIndex(name, id, dp);
	if (id >= 0)
		return stack[dp].substack[id].delimiter;

	return wstring(L"");
}

//----

wstring	CLocalVariable::GetDelimiter(const wstring &name)
{
	int	dp, id;
	GetIndex(name, id, dp);
	if (id >= 0)
		return stack[dp].substack[id].delimiter;

	return wstring(L"");
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::SetDelimiter
 *  @\TvF  w肳ꂽ[Jϐɒli[܂
 * -----------------------------------------------------------------------
 */
void	CLocalVariable::SetDelimiter(const wchar_t *name, const wstring &value)
{
	int	dp, id;
	GetIndex(name, id, dp);
	if (id >= 0) {
		stack[dp].substack[id].delimiter = value;
		return;
	}

	// X^bNɑ݂ȂΕϐVɍ쐬đ
	Make(name, value);
}

//----

void	CLocalVariable::SetDelimiter(const wstring &name, const wstring &value)
{
	int	dp, id;
	GetIndex(name, id, dp);
	if (id >= 0) {
		stack[dp].substack[id].delimiter = value;
		return;
	}

	// X^bNɑ݂ȂΕϐVɍ쐬đ
	Make(name, value);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::SetValue
 *  @\TvF  w肳ꂽ[Jϐɒli[܂
 * -----------------------------------------------------------------------
 */
void	CLocalVariable::SetValue(const wchar_t *name, const CValue &value)
{
	int	dp, id;
	GetIndex(name, id, dp);
	if (id >= 0) {
		stack[dp].substack[id].v = value;
		return;
	}

	// X^bNɑ݂ȂΕϐVɍ쐬đ
	Make(name, value);
}

//----

void	CLocalVariable::SetValue(const wstring &name, const CValue &value)
{
	int	dp, id;
	GetIndex(name, id, dp);
	if (id >= 0) {
		stack[dp].substack[id].v = value;
		return;
	}

	// X^bNɑ݂ȂΕϐVɍ쐬đ
	Make(name, value);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::GetMacthedLongestNameLength
 *  @\TvF  w肳ꂽɃ}b`閼OϐTA}b`Ԃ܂
 *
 *  ꍇ͍Œ̂̂Ԃ܂BȂꍇ0Ԃ܂
 * -----------------------------------------------------------------------
 */
int	CLocalVariable::GetMacthedLongestNameLength(const wstring &name)
{
	int	max_len = 0;

	for(int i = stack.size() - 1; i >= 0; i--)
		for(int j = stack[i].substack.size() - 1; j >= 0; j--) {
			int	len = stack[i].substack[j].name.size();
			if (!stack[i].substack[j].IsErased() &&
				max_len < len &&
				!stack[i].substack[j].name.compare(name.substr(0, len)))
				max_len = len;
		}

	return max_len;
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLocalVariable::Erase
 *  @\TvF  w肳ꂽϐ܂
 *
 *  ۂɔz񂩂킯ł͂ȂA󕶎邾ł
 * -----------------------------------------------------------------------
 */
void	CLocalVariable::Erase(const wstring &name)
{
	int	id, dp;
	GetIndex(name, id, dp);
	if (id >= 0)
		SetValue(name, CValue());
}
