// 
// AYA version 5
//
// MOpNX@CLog
// written by umeici. 2004
// 

#ifndef POSIX
#  include "stdafx.h"
#else
#  include "posix_utils.h"
#  include "messages.h"
#  include <sys/time.h>
#  include <iostream>
#endif
#include "basis.h"
#include "comment.h"
#include "wsex.h"
#include "misc.h"
#include "log.h"
#include "ccct.h"

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::Start
 *  @\TvF  MOJn܂
 * -----------------------------------------------------------------------
 */
#ifndef POSIX
void	CLog::Start(const wstring &p, int cs, int ml, HWND hw, char il)
#else
void	CLog::Start(const wstring &p, int cs, int ml, char il)
#endif
{
	path    = p;
	charset = cs;
	msglang = ml;
#ifndef POSIX
	hWnd    = hw;
#endif
	iolog   = il;
#ifdef POSIX
	fix_filepath(path);
#endif
	
#ifndef POSIX
	// hWndNULLȂÑ`FbNc[TĎ擾
	if (hWnd == NULL)
		hWnd = GetCheckerWnd();
#endif

	// MOL/̔
	if (!path.size()) {
		fileen = 0;
#ifndef POSIX
		if (hWnd == NULL) {
			enable = 0;
			return;
		}
#else
		enable = 0;
		return;
#endif
	}

	// 쐬
	wstring	str = (msglang) ? msge[0] : msgj[0];
	str += GetDateString();
	str += L"\n\n";

	// t@C֏
	if (fileen) {
		char	*tmpstr = Ccct::Ucs2ToMbcs(str, charset);
		if (tmpstr != NULL) {
			FILE	*fp = w_fopen((wchar_t *)path.c_str(), L"w");
			if (fp != NULL) {
/*				if (charset == CHARSET_UTF8)
					write_utf8bom(fp);*/
				fprintf(fp, "%s", tmpstr);
				fclose(fp);
			}
			free(tmpstr);
		}
	}

#ifndef POSIX
	// `FbNc[֑o@ŏɕR[hݒ肵Ă當𑗏o
	if (charset == CHARSET_SJIS)
		SendLogToWnd(L"", E_SJIS);
	else if (charset == CHARSET_UTF8)
		SendLogToWnd(L"", E_UTF8);
	else	// CHARSET_DEFAULT
		SendLogToWnd(L"", E_DEFAULT);

	SendLogToWnd(str, E_I);
#endif
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::Termination
 *  @\TvF  MOI܂
 * -----------------------------------------------------------------------
 */
void	CLog::Termination(void)
{
	if (!enable)
		return;

	Message(1);

	wstring	str = GetDateString();
	str += L"\n\n";

	Write(str);

#ifndef POSIX
	SendLogToWnd(L"", E_END);
#endif
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::Write
 *  @\TvF  Oɕ݂܂
 * -----------------------------------------------------------------------
 */
void	CLog::Write(const wstring &str, int mode)
{
	if (!enable)
		return;

	// 񒆂\r͏
	wstring	cstr = str;
	int	len = cstr.size();
	for(int i = 0; i < len; ) {
		if (cstr[i] == L'\r') {
			cstr.erase(i, 1);
			len--;
			continue;
		}
		i++;
	}

	// t@C֏
	if (fileen) {
		char	*tmpstr = Ccct::Ucs2ToMbcs(cstr, charset);
		if (tmpstr != NULL) {
			FILE	*fp = w_fopen((wchar_t *)path.c_str(), L"a");
			if (fp != NULL) {
				fprintf(fp, "%s", tmpstr);
				fclose(fp);
			}
			free(tmpstr);
		}
	}

#ifndef POSIX
	// `FbNc[֑o
	SendLogToWnd(cstr, mode);
#endif
}

//----

void	CLog::Write(const wchar_t *str, int mode)
{
	if (str == NULL)
		return;
	if (!wcslen(str))
		return;

	wstring	lstr = str;
	Write(lstr, mode);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::Filename
 *  @\TvF  ̃tH[}bgŃt@COɋL^܂
 * -----------------------------------------------------------------------
 */
void	CLog::Filename(const wstring &filename)
{
	wstring	str =  L"- ";
	str += filename;
	str += L"\n";
	Write(str);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::Message
 *  @\TvF  idŎw肳ꂽ̃bZ[WOɏ݂܂
 * -----------------------------------------------------------------------
 */
void	CLog::Message(int id)
{
	Write((msglang) ? (wchar_t *)msge[id] : (wchar_t *)msgj[id], 0);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::Error
 *  @\TvF  OmodeidŎw肳ꂽG[݂܂
 *
 *  @@F@ref         t
 *  @@@@@  dicfilename G[Nӏ܂ގt@C̖O
 *  @@@@@  linecount   G[Nsԍ
 *
 *  @@@@@  refdicfilenameNULLAlinecount-1Ƃ邱ƂŁA
 *  @@@@@  \ɂł܂
 * -----------------------------------------------------------------------
 */
void	CLog::Error(int mode, int id, const wchar_t *ref, const wstring &dicfilename, int linecount)
{
	if (!enable)
		return;

	// Oɏݕ쐬it@Cƍsԍj
	wstring	logstr;
	if (dicfilename.empty())
		logstr = L"-(-) : ";
	else {
		logstr = dicfilename + L"(";
		if (linecount == -1)
			logstr += L"-) : ";
		else {
			wstring	lcstr;
			ws_itoa(lcstr, linecount, 10);
			logstr += lcstr;
			logstr += L") : ";
		}
	}
	// Oɏݕ쐬i{j
	if (msglang) {
		// p
		if (mode == E_F)
			logstr += msgfe[id];
		else if (mode == E_E)
			logstr += msgee[id];
		else if (mode == E_W)
			logstr += msgwe[id];
		else
			logstr += msgne[id];
	}
	else {
		// {
		if (mode == E_F)
			logstr += msgfj[id];
		else if (mode == E_E)
			logstr += msgej[id];
		else if (mode == E_W)
			logstr += msgwj[id];
		else
			logstr += msgnj[id];
	}
	// Oɏݕ쐬itj
	if (ref != NULL) {
		logstr += L" : ";
		logstr += ref;
	}
	// 
	logstr += L'\n';
	Write(logstr, mode);
}

//----

void	CLog::Error(int mode, int id, const wstring& ref, const wstring& dicfilename, int linecount)
{
	Error(mode, id, (wchar_t *)ref.c_str(), dicfilename, linecount);
}

//----

void	CLog::Error(int mode, int id, const wchar_t *ref)
{
        Error(mode, id, ref, wstring(), -1);
}

//----

void	CLog::Error(int mode, int id, const wstring& ref)
{
        Error(mode, id, (wchar_t *)ref.c_str(), wstring(), -1);
}

//----

void	CLog::Error(int mode, int id, const wstring& dicfilename, int linecount)
{
	Error(mode, id, (wchar_t *)NULL, dicfilename, linecount);
}

//----

void	CLog::Error(int mode, int id)
{
        Error(mode, id, (wchar_t *)NULL, wstring(), -1);
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::Io
 *  @\TvF  o͕ƎsԂOɋL^܂
 *  @@F  io 0/1=Jn/I
 * -----------------------------------------------------------------------
 */
void	CLog::Io(char io, const wstring &str)
{
	if (!enable || !iolog)
		return;

	static int		starttime = 0;
	static	wchar_t	t_str[STRMAX];

	if (!io) {
		Write(L"// request\n");
		Write(str + L"\n");
#ifndef POSIX
		starttime = GetTickCount();
#else
		struct timeval tv;
		gettimeofday(&tv, NULL);
		starttime = tv.tv_sec * 1000 + tv.tv_usec / 1000;
#endif
	}
	else {
#ifndef POSIX
		swprintf(t_str, L"// response (Execution time : %d[ms])\n", GetTickCount() - starttime);
#else
		struct timeval tv;
		gettimeofday(&tv, NULL);
		swprintf(t_str, STRMAX, L"// response (Execution time : %d[ms])\n", tv.tv_sec * 1000 + tv.tv_usec / 1000 - starttime);
#endif
		Write(t_str);
		Write(str + L"\n");
	}
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::IoLib
 *  @\TvF  OCuo͕ƎsԂOɋL^܂
 *  @@F  io 0/1=Jn/I
 * -----------------------------------------------------------------------
 */
void	CLog::IoLib(char io, const wstring &str, const wstring &name)
{
	if (!enable || !iolog)
		return;

	static int		starttime = 0;
	static	wchar_t	t_str[STRMAX];

	if (!io) {
		Write(L"// request to library\n// name : ");
		Write(name + L"\n");
		Write(str + L"\n");
#ifndef POSIX
		starttime = GetTickCount();
#else
		struct timeval tv;
		gettimeofday(&tv, NULL);
		starttime = tv.tv_sec * 1000 + tv.tv_usec / 1000;
#endif
	}
	else {
#ifndef POSIX
		swprintf(t_str, L"// response from library (Execution time : %d[ms])\n", GetTickCount() - starttime);
#else
		struct timeval tv;
		gettimeofday(&tv, NULL);
		swprintf(t_str, STRMAX, L"// response from library (Execution time : %d[ms])\n", tv.tv_sec * 1000 + tv.tv_usec / 1000 - starttime);
#endif
		Write(t_str);
		Write(str + L"\n");
	}
}

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::SendLogToWnd
 *  @\TvF  `FbNc[ɐ䃁bZ[WуOWM_COPYDATAőM܂
 * -----------------------------------------------------------------------
 */
#ifndef POSIX
void	CLog::SendLogToWnd(const wchar_t *str, int mode)
{
	if (hWnd == NULL)
		return;

	COPYDATASTRUCT cds;
	cds.dwData = mode;
	cds.cbData = (wcslen(str) + 1)*sizeof(wchar_t);
	cds.lpData = (LPVOID)str;
	::SendMessage(hWnd, WM_COPYDATA, (WPARAM)NULL, (LPARAM)&cds);
}

//----

void	CLog::SendLogToWnd(const wstring &str, int mode)
{
	SendLogToWnd((wchar_t *)str.c_str(), mode);
}
#endif

/* -----------------------------------------------------------------------
 *  ֐  F  CLog::GetCheckerWnd
 *  @\TvF  `FbNc[hWnd擾܂
 * -----------------------------------------------------------------------
 */
#ifndef POSIX
HWND	CLog::GetCheckerWnd(void)
{
	return FindWindow(CLASSNAME_CHECKTOOL, NULL);
}
#endif
