// 
// AYA version 5
//
// stl::wstringchar*Ɏg߂̊֐Ȃ
// written by umeici. 2004
// 

#ifndef POSIX
#  include "stdafx.h"
#else
#  include "posix_utils.h"
#  include "messages.h"
#  include <wchar.h>
#  include <iostream>
#  include <sstream>
#  include <iomanip>
#  include <boost/lexical_cast.hpp>
using namespace std;
using namespace boost;
#endif
#include "wsex.h"
#include "ccct.h"
#include "misc.h"
#include "log.h"
#include "basis.h"

extern CBasis	basis;
extern CLog		logger;

/* -----------------------------------------------------------------------
 *  ֐  F  ws_atoi
 *  @\TvF  wstringint֕ϊ
 * -----------------------------------------------------------------------
 */
int	ws_atoi(const wstring &str, int base)
{
	int	len = str.size();
	if (!len)
		return 0;

	wchar_t	*dmy;
	return (int)wcstol(str.c_str(), &dmy, base);
}

/* -----------------------------------------------------------------------
 *  ֐  F  ws_atof
 *  @\TvF  wstringdouble֕ϊ
 * -----------------------------------------------------------------------
 */
double	ws_atof(const wstring &str)
{
	int	len = str.size();
	if (!len)
		return 0.0;

	wchar_t	*dmy;
	return wcstod(str.c_str(), &dmy);
}

/* -----------------------------------------------------------------------
 *  ֐  F  ws_itoa
 *  @\TvF  intwstring֕ϊ
 * -----------------------------------------------------------------------
 */
#ifndef POSIX
void	ws_itoa(wstring &str, int num, int base)
{
	wchar_t	tmpstr[WS_MAXLEN];
	_itow(num, tmpstr, base);
	str = tmpstr;
}
#else
void ws_itoa(wstring &str, int num, int base) {
    ostringstream s;
    s << setbase(base) << num;
    str = widen(s.str());
}
#endif

/* -----------------------------------------------------------------------
 *  ֐  F  ws_ftoa
 *  @\TvF  doublewstring֕ϊ
 *
 * ǂ΂̂Ȃ̂ŁA܂swprintfŕϊĂ
 * I[̖ʂL'0'Ƃ䏈ɂĂ܂
 * -----------------------------------------------------------------------
 */
void	ws_ftoa(wstring &str, double num)
{
	wchar_t	tmpstr[WS_MAXLEN];
#ifndef POSIX
	swprintf(tmpstr, L"%lf", num);
#else
	swprintf(tmpstr, WS_MAXLEN, L"%lf", num);
#endif
	str = tmpstr;

	for( ; ; ) {
		if (str.size() < 4)
			break;
		wchar_t	lastword = str[str.size() - 1];
		if (lastword == L'0')
			str.erase(str.end() - 1);
		else {
			if (lastword == L',')
				str += L'0';
			break;
		}
	}
}

/* -----------------------------------------------------------------------
 *  ֐  F  ws_eraseend
 *  @\TvF  wstring̏I[c
 * -----------------------------------------------------------------------
 */
void	ws_eraseend(wstring &str, wchar_t c)
{
	int	len = str.size();
	if (!len)
		return;

	if (str[len - 1] == c)
		str.erase(str.end() - 1);
}

/* -----------------------------------------------------------------------
 *  ֐  F  ws_replace
 *  @\TvF  strbeforeׂafterɒu܂
 * -----------------------------------------------------------------------
 */
void	ws_replace(wstring &str, const wstring &before, const wstring &after)
{
	int	sz_bef = before.size();
	int	sz_aft = after.size();
	for(int rp_pos = 0; ; rp_pos += sz_aft) {
		rp_pos = str.find(before, rp_pos);
		if (rp_pos == -1)
			break;
		str.replace(rp_pos, sz_bef, after);
	}
}

/* -----------------------------------------------------------------------
 *  ֐  F  w_fopen
 *  @\TvF  UCS-2̃t@CŃI[vłfopen
 *
 *  ⑫@wchar_t*𒼐ړn_wfopenWin9xnT|[ĝߎgȂ̂łBOB
 * -----------------------------------------------------------------------
 */
#ifndef POSIX
FILE	*w_fopen(const wchar_t *fname, const wchar_t *mode)
{
	// t@CƃI[v[hMBCS֕ϊ
	char	*mfname = Ccct::Ucs2ToMbcs(fname, CHARSET_DEFAULT);
	if (mfname == NULL)
		return NULL;
	char	*mmode  = Ccct::Ucs2ToMbcs(mode,  CHARSET_DEFAULT);
	if (mmode == NULL) {
		free(mfname);
		return NULL;
	}
	// I[v
	FILE	*fp = fopen(mfname, mmode);
	free(mfname);
	free(mmode);

	return fp;
}
#else
FILE* w_fopen(const wchar_t* fname, const wchar_t* mode) {
    string s_fname = narrow(wstring(fname));
    string s_mode = narrow(wstring(mode));

    fix_filepath(s_fname);

    return fopen(s_fname.c_str(), s_mode.c_str());
}
#endif

/* -----------------------------------------------------------------------
 *  ֐  F  write_utf8bom
 *  @\TvF  UTF-8 BOM
 * -----------------------------------------------------------------------
 */
/*
void	write_utf8bom(FILE *fp)
{
	fputc(0xef, fp);
	fputc(0xbb, fp);
	fputc(0xbf, fp);
}
*/
/* -----------------------------------------------------------------------
 *  ֐  F  ws_fgets
 *  @\TvF  wstringɎoȈՔfgetsAÍUCS-2 BOM폜sȂ
 * -----------------------------------------------------------------------
 */
int ws_fgets(wstring &str, FILE *stream, int charset, int ayc/*1AYC*/, int lc/*1BOM`FbNON*/) {
    string buf;
    int c;
    while (true) {
	c = fgetc(stream);
	if (c == EOF) {
	    break;
	}
	if (ayc) {
	    decodecipher(c);
	}
	buf += static_cast<char>(c);
	if (c == '\x0a') {
	    // s̏I
	    break;
	}
    }

    wchar_t *wstr = Ccct::MbcsToUcs2(buf, charset);
    str = wstr;
    free(wstr);

    if (charset == CHARSET_UTF8 && lc == 1) {
	cutbom(str);
    }

    if (c == EOF && str.empty()) {
	return WS_EOF;
    }
    else {
	return str.size();
    }
}

/* -----------------------------------------------------------------------
 *  ֐  F  cutbom
 *  @\TvF  wstring擪UCS-2 BOM菜
 * -----------------------------------------------------------------------
 */
void	cutbom(wstring &wstr)
{
	if (wstr.size() < 2)
		return;
	if (wstr[0] == (wchar_t)0xfeff || wstr[0] == (wchar_t)0xffef)
		wstr.erase(0, 1);
}

/* -----------------------------------------------------------------------
 *  ֐  F  decodecipher
 *  @\TvF  AYAÍꂽ𕜍
 *
 *  ̃rbg]Ƃł
 * -----------------------------------------------------------------------
 */
inline void	decodecipher(int &c)
{
	c = (((c & 0x7) << 5) + (c >> 3)) ^ 0x5a;
}

